
    '3D surface 12
    'Dedicated to our colonial cousins & their spelling of color

    nomainwin

    UpperLeftX     =  10
    UpperLeftY     =  10
    WindowWidth    = 700
    WindowHeight   = 540

    graphicbox #w.g     5,  80,  560, 400
    graphicbox #w.g2  594, 320,   66,  40

    loadbmp "ht",   "ht.bmp"
    loadbmp "rad", "rad.bmp"

    texteditor #w.t   5,   5, 560,  72

    button     #w.b1, "Colour coding?", [colour], LR,  90, 110
    button     #w.b2, "Quit", [quit],             LR,  30,   5
    button     #w.b3, "Draw ", [shapedraw],       LR,  30,  50
    button     #w.b4, "Clear", [clear],           LR,  30,  80
    button     #w.b5, "Save", [savebmp],          LR,  90,  80

    radiobutton #w.rb0, "Ledge",        [set0], [reset], 580,  10,  90,  30
    radiobutton #w.rb1, "Cos R",        [set1], [reset], 580,  40,  90,  30
    radiobutton #w.rb2, "SincR",        [set2], [reset], 580,  70,  90,  30
    radiobutton #w.rb3, "Radius",       [set3], [reset], 580, 100,  90,  30
    radiobutton #w.rb4, "100 -R",       [set4], [reset], 580, 130,  90,  30
    radiobutton #w.rb5, "Sqr  R",       [set5], [reset], 580, 160,  90,  30
    radiobutton #w.rb6, "Sqrt R",       [set6], [reset], 580, 190,  90,  30
    radiobutton #w.rb7, "R Div n",      [set7], [reset], 580, 220,  90,  30
    radiobutton #w.rb8, "R Mod n",      [set8], [reset], 580, 250,  90,  30
    radiobutton #w.rb9, "Dipole",       [set9], [reset], 580, 280,  90,  30
    groupbox    #w.gp,  "Function",                      574,  00,  90, 320

    open "3D surface display   v12       John Fisher    Dec 2002" for window as #w

    #w.g "down ; fill darkblue ; color white"
    #w.g2 "drawbmp ht 0 0"

    #w.t "!font times_roman 10"
    #w.t                " This program draws pseudo 3D views of functions of radius or of x, y."_
            +chr$(10) + " The axes & x,y plane are drawn too."_
            +chr$(10) + " The demo functions have been scaled or offset vertically for display purposes."_
            +chr$(10) + " You can select colour coding by height or by radius from the origin"_
            +chr$(10)_
            +chr$(10) + " Oh for a built-in expression evaluator!"_
            +chr$(10) + " PLEASE, Carl?? And 'unary minus' so I don't have to use 0-y?"_
            +chr$(10) + " Others- do add new functions of radius or x,y."_
            +chr$(10) + " Still a 'work in progress'."_
            +chr$(10) + " Known bugs- crashes LB regularly!!"_
            +chr$(10) + " Will be updating but welcome others who'll improve it.."
    #w.t "!origin 0 0"
    'I can't see why there are crashes in usually-stable LB. Prob. in the colour/point select
       '    where its picky on having integers? Or the 'goto's and for/next exits?
       '    Also why doesn't 'line' use 'size'?
    #w "trapclose [quit]"

    dot     =  1
    type    =  2
    choice  =  2

    [shapedraw]
    sx      =560
    sy      =450
    ratio   =  1.5
    hy      =sy /2
    hx      =sx /2
    s       =2^0.5 /2
    aa      =hx *s
    ma      =  0

    #w.g   "size "; str$( dot)
    #w.rb2 "set ";  chr$( type)

    #w.g "color red size 4"
    #w.g "line 280 202 480 300"
    #w.g "line 480 300 280 396"
    #w.g "line 280 396  80 300"
    #w.g "line  80 300 280 202"

    #w.g "color yellow size 4"
    #w.g "line 180 351 380 249"
    #w.g "line 180 249 380 351"
    #w.g "line 280  50 280 300"
    #w.g "size 1"

    for a = ( 0 -aa) to ( aa +5 *s) step dot
        ma  =( 0 -hy)
        bb  =aa +a -10 *s *int(( a +abs( a)) /(10 *s))
        for b = 0 -bb to bb +s *4 step 10 *s *dot
            x =s *( a +b)
            y =s *( b -a)
            r =int( x^2 +y^2)^0.5
            z =myfunc( r, x, y, choice) +b
            if z >=ma then
                ma =z
                u  =hx +a
                v  =sy -( hy +z *s) /ratio
                if type =1 then
                    c$=str$( int( r)) +" " +str$( 255)_
                         +" " +str$( int( abs( 255 -r)))                   ' colour based on radius
                else
                    c$ =str$( int( abs( myfunc( r, x, y, choice))))_
                         +" " +str$( 255) +" "_
                         +str$( int( abs( 255 -myfunc( r, x, y, choice)))) ' colour based on height
                end if
                #w.g "color "; c$
                #w.g "set "; str$( int( u)); " "; str$( int( v))
            end if
            scan
        next b
    next a

    #w.g "flush"

    wait

    [colour]
    if type =1 then
        type =0
        #w.b1 "by height"
        #w.g2 "drawbmp ht  0 0"
    else
        type =1
        #w.b1 "by radius"
        #w.g2 "drawbmp rad 0 0"
    end if
    wait

    [savebmp]
    #w.g "getbmp 3Dfig 1 1 558 448"
    bmpsave "3Dfig", "3Dfig.bmp"
    goto [shapedraw]
    wait

    [clear] #w.g "fill darkblue discard": wait

    [set0]  choice = 0: wait
    [set1]  choice = 1: wait
    [set2]  choice = 2: wait
    [set3]  choice = 3: wait
    [set4]  choice = 4: wait
    [set5]  choice = 5: wait
    [set6]  choice = 6: wait
    [set7]  choice = 7: wait
    [set8]  choice = 8: wait
    [set9]  choice = 9: wait

    function myfunc( r, x, y, choice)
    'So much easier to enter functions in languages with an expression evaluator, Carl....
    select case choice
        case 0
            if x>40 and y >80 then zz =40 else zz =0
            if x<0-60 and y <0-40 then zz =0-60
        case 1
            zz =  50 *cos( r /20)
        case 2
            if r <>0 then zz =2000 *( sin( r /6)) /r else zz =0
        case 3
            if r >100 then zz =b else zz =r
        case 4
            if r >100 then zz =b else zz =( 100 -r)
        case 5
            if r >100 then zz =b else zz =0.06 *( 100 -r)^2
        case 6
            if r >=100 then zz =b else zz =50 *( 100 -r)^0.5
        case 7
            r      =r +50
            rdiv50 =int( r /50)
            rmod50 =(r /50 -rdiv50) *100
            zz =400 -rdiv50 *30 ' currently selects mod function
        case 8
            r      =r +50
            rdiv50 =int( r/50)
            rmod50 =(r /50 -rdiv50) *100
            zz =rmod50 ' alternate functions div & mod to try
        case 9
            a=(( 60-x)^2+(-60-y)^2)^0.5
            b=((-60-x)^2+( 60-y)^2)^0.5
            if a <>0 and b <>0 then zz =1000/a -2000 /b else zz =0
        case else
    end select
    myfunc =zz
    end function

    [quit]
    close #w
    end

